/*
	Change Log
    Fix  "Delete last empty lines" bug   05/17/2011
	     Skip skip function while list is empty.
	Fix list_read is case of file empty,
		'Delete last empty lines' function will
		crash the program.			07/03/2008
*/
#ifdef WIN32
#include <stdio.h>
#else
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#endif

#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include "llist.h"
#include "String.h"

extern int RevRep, Log, Diff;

struct llist_element *laste = NULL;
struct llist *lastl = NULL;
int lastID = 0;

void llist_init(struct llist *l)
{
  l->size = 0;
  l->head = NULL;
  l->tail = NULL;
}

struct llist * llist_alloc()
{
  struct llist *list;
/*  list = (struct llist *)malloc(sizeof(struct llist)); */
#ifdef Gmem
  list =(struct llist *) gmem_get(sizeof(struct llist));
#else
  list = (struct llist *)malloc(sizeof(struct llist));
#endif

  if(NULL == list) return NULL;
  llist_init(list);
  return list;
}

/*
 * llist_insert_next() returns 1 on success and 0 on failure.
 */
struct llist_element *
llist_insert_next(struct llist *list, struct llist_element *e,
                       char *p1, char *p2)
{
  struct llist_element *ne =
/*    (struct llist_element *) malloc(sizeof(struct llist_element)); */
#ifdef Gmem
    (struct llist_element *) gmem_get(sizeof(struct llist_element));
#else
    (struct llist_element *) malloc(sizeof(struct llist_element));
#endif
	if(!ne)
    return NULL;
/*
    ne->ptr1 = (void *) p1;
    ne->ptr2 = (void *) p2;
    fprintf (stderr, "*p1=>%s<, *p2=>%s<\n", p1, p2);
*/
  if ( strlen(p1)) ne->ptr1 = memcpyx (p1);
	else ne->ptr1 = NULL;
  /* ne->ptr1 = memcpyx (p1); */
  if ( strlen(p2)) ne->ptr2 = memcpyx (p2);
    else ne->ptr2 = NULL;
  /* ne->ptr2 = memcpyx (p2); */
  ne->list1 = NULL;
  ne->list2 = NULL;

  if (e == NULL) ne->ID = 0;
  else {
	  if (e->ID >= 0) ne->ID = -(e->ID);
	  else ne->ID = e->ID;
  }

  if (list->size == 0) {
    list->head = ne;
    list->head->prev = NULL;
    list->head->next = NULL;
    list->tail = ne;
  }
  else {
    ne->next = e->next;
    ne->prev = e;
    if (e->next) {
      e->next->prev = ne;
    }
    else {
      list->tail = ne;
    }
    e->next = ne;
  }
  ++list->size;
  return ne;
}

struct llist_element *
llist_insert_prev(struct llist *list, struct llist_element *e,
                       char *p1, char *p2)
{
  struct llist_element *ne =
/*    (struct llist_element *) malloc(sizeof(struct llist_element)); */
#ifdef Gmem
    (struct llist_element *) gmem_get(sizeof(struct llist_element));
#else
     (struct llist_element *) malloc(sizeof(struct llist_element));
#endif

  if(!ne)
    return NULL;
/*
    ne->ptr1 = (void *) p1;
    ne->ptr2 = (void *) p2;
    fprintf (stderr, "*p1=>%s<, *p2=>%s<\n", p1, p2);
*/
  if ( strlen(p1)) ne->ptr1 = memcpyx (p1);
	else ne->ptr1 = NULL;
  if ( strlen(p2)) ne->ptr2 = memcpyx (p2);
    else ne->ptr2 = NULL;
  ne->list1 = NULL;
  ne->list2 = NULL;
  if (e->prev == NULL) ne->ID = 0;
  else { if (e->prev->ID > 0) ne->ID = -(e->prev->ID);
	else ne->ID = e->prev->ID;
  }
  if (list->size == 0) {
    list->head = ne;
    list->head->prev = NULL;
    list->head->next = NULL;
    list->tail = ne;
  }
  else {
    ne->prev = e->prev;
    ne->next = e;
    if (e->prev) {
      e->prev->next = ne;
    }
    else {
      list->head = ne;
    }
    e->prev = ne;
  }
  ++list->size;
  return ne;
}

struct llist_element *
llist_remove(struct llist *list, struct llist_element *e)
{
struct llist_element * temp;

  temp = e->next;
  /* temp = e->prev; */
  if (e == NULL || list->size == 0)
    return NULL;
  if (e == list->head) {
    list->head = e->next;
    if (list->head == NULL)
      list->tail = NULL;
    else
      e->next->prev = NULL;
  } else {
    e->prev->next = e->next;
    if (!e->next)
      list->tail = e->prev;
    else
      e->next->prev = e->prev;
  }
  if (e->ptr1)
/*	  free(e->ptr1); */
#ifdef Gmem
	  gmem_free((unsigned long *) e->ptr1);
#else
	  free(e->ptr1);
#endif
  if (e->ptr2)
/*	  free(e->ptr2); */
#ifdef Gmem
	  gmem_free((unsigned long *) e->ptr2);
#else
	  free(e->ptr2);
#endif
  if (e->list1) llist_destroy(e->list1);
  if (e->list2) llist_destroy(e->list2);
/*  free(e); */
#ifdef Gmem
  gmem_free((unsigned long *) e);
#else
  free(e);
#endif
  --list->size;
  return temp;
}

void
llist_destroy(struct llist *list)
{
  if(list) {
    while (list->size > 0)
      llist_remove(list, list->tail);
/*    free(list); */
#ifdef Gmem
	gmem_free((unsigned long *)list);
#else
	free((unsigned long *)list);
#endif
  }
}

char * memcpyx (char * p)
{
	char * x;

/*	x = (char *) malloc(strlen(p)+1); */
#ifdef Gmem
	x = (char *) gmem_get(strlen(p)+1);
#else
      x = (char *) malloc(strlen(p)+1);
#endif

    	if (x) {
    		strcpy(x, p);
/*    		fprintf (stderr, "*p=>%s<, x=>%s<\n", p, x); */
    		return x;
    	} else {
    		return NULL;
    	}
}

char * memrepx (char * p, char * n)
{
	char * x;

/*	free(p); */
#ifdef Gmem
	gmem_free((unsigned long *) p);
/*	x = (char *) malloc(strlen(n)+1); */
	x = (char *) gmem_get(strlen(n)+1);
#else
	free(p);
	x = (char *) malloc(strlen(n)+1);
#endif

    	if (x) {
    		strcpy(x, n);
/*    		fprintf (stderr, "*p=>%s<, x=>%s<\n", p, x); */
    		return x;
    	} else {
    		return NULL;
    	}
}


struct llist * ListLoad(char * FileIn)
{
	FILE *fi;
	struct llist * FileList;
	int i, j;
	char * p1;

	/* open input/output file */
	fi = fopen (FileIn, "rt");
	if (fi == NULL) {
		fprintf(stderr, "Input file open error >%s<.\n", FileIn);
		if (Log) fprintf(stderr, "Input file open error >%s<.\n", FileIn);
		return NULL;
	}
	/* Build Compare list */

	FileList = llist_alloc();
	if (FileList == NULL) {
		fclose (fi);
		return NULL;
	}
	j = 1;
	while (!feof(fi)) {
		/* i = ReadLine(fi, argv, 1024); */
		p1 = ReadLineX(fi, &i);
		if (i) {
			llist_insert_next(FileList, FileList->tail, p1, "");
			/*
			fprintf(stderr, "ReadLine:argv = %s\n        :Par[0]>%s< Par[1] >%s<\n",
			        argv, Par[0], Par[1]);
			*/
		} else {
			llist_insert_next(FileList, FileList->tail, "", "");

		}
		FileList->tail->ID = j++;
		if (p1) free ((unsigned long *)p1);
	}
	fclose (fi);
	if (FileList->size==0) {
		if (FileList) llist_destroy(FileList);
		FileList = NULL;
		return NULL;
	}
	return FileList;
}

int ListDump(struct llist *FileList,
			 char * FileIn, char * FileOut)
{
	FILE *fo;
	struct llist_element *line01, *temp;

	if (strlen(FileOut) != 0) {
		fo = fopen (FileOut, "wt");
		if (fo == NULL) {
			fprintf(stderr, "Output file open error >%s<.\n", FileOut);
/*			if (Log) fprintf(flog, "Output file open error >%s<.\n", FileOut); */
			if (FileList) llist_destroy(FileList);
			return 1;
		}
	} else {
		fo = fopen ("Working.txt", "wt");
		if (fo == NULL) {
			fprintf(stderr, "Output working.txt file open error.\n");
/*			if (Log) fprintf(flog, "Output working.txt file open error.\n"); */
			if (FileList) llist_destroy(FileList);
			return 1;
		}
	}
	line01 = FileList->head;
	while (line01) {
		if (line01->ptr1) fprintf(fo, "%s\n", line01->ptr1);
		else fprintf(fo, "\n");
		if (line01->list1) {	/*  print insert list also */
			temp =line01->list1->head;
			while (temp) {
				if (temp->ptr1) fprintf(fo, "%s\n", temp->ptr1);
				else fprintf(fo, "\n");

				temp = temp->next;
			}
		}
		line01 = line01->next;
	}
	fflush( fo);
	fclose (fo);
	if (strlen(FileOut) == 0) {
		if (remove (FileIn)==-1)
			printf ("remove file %s error.\n", FileIn);
		if (rename ("Working.txt", FileIn))
			printf ("rename file working.txt error.\n");
	}

	if (FileList) llist_destroy(FileList);
	return 0;
}


char * GetLine (struct llist * list, int id)
{
	struct llist_element *e;

	if (list==NULL) goto NotFound;
	if (list->size == 0) goto NotFound;
	if (id>list->size) goto NotFound;

	if (list == lastl && lastID ==id) {
			e = laste->next;
			goto Next01;
	}

	e = list->head;
Next01:
	if (e->ID == id) {
		lastl = list;
		laste = e;
		lastID = id + 1;
		return e->ptr1;
	}
	if (e->ID<list->size) {
		e = e->next;
		goto Next01;
	}
NotFound:
	lastl = NULL;
	laste = NULL;
	return NULL;
}


struct llist * list_read (char * FileName)
{
	FILE *fi;
	struct llist * llist;
	char buffer[256], * x;
	int count, length, lengthx;

/*	LLISTELEM dump; */

	/* fi = fopen (FileName, "rt"); */
	fi = fopen (FileName, "rb");
	if (fi == NULL) {
		fprintf (stderr, "File >%s< open error.\n", FileName);
		return NULL;
	}
	count = 1;
	llist = llist_alloc();
	if (llist == NULL) {
		fclose (fi);
		return NULL;
	}

	while (!feof(fi)) {
		/* length = ReadLine(fi, buffer, 256); */
#ifdef Encryption
		length = EncryptLineRead(fi, buffer, 256);
#else
		length = ReadLine(fi, buffer, 256);
#endif
		/* Skip last blank line */
		if (feof(fi) && length == 0) break;
		/* protect for read in data error.(emptry) */
		if (buffer[0] == 0) length = 0;
		llist_insert_next (llist,
					       llist->tail,
						   buffer, "");
		llist->tail->ID = count;
		count++;

		lengthx = -length;
		/* Record great than buffer size? */
more01: /* Read more */
		if (length>=0) goto RTrim;

		if (!feof(fi)) {
			/* length = ReadLine(fi, buffer, 256); */
#ifdef Encryption
			length = EncryptLineRead(fi, buffer, 256);
#else
			length = ReadLine(fi, buffer, 256);
#endif
			if (length==0) goto RTrim;
			if (length>0) lengthx += length;
			else lengthx -= length;
#ifdef Gmem
			x = (char *) gmem_get(lengthx+1);
#else
			x = (char *) malloc(lengthx+1);
#endif
    		if (x) {
    			strcpy(x, llist->tail->ptr1);
				strcat (x, buffer);
#ifdef Gmem
				gmem_free((unsigned long *)llist->tail->ptr1);
#else
				free(llist->tail->ptr1);
#endif
				llist->tail->ptr1 = x;
			}
			goto more01;
		}
RTrim:
		if (length==0) continue;
		 /* R᭱ť */
		length = strlen(llist->tail->ptr1) - 1;
		if (length>0) {
			while ((*(llist->tail->ptr1+length) == ' ' ||
				    *(llist->tail->ptr1+length) == 9) &&
				length>0) length--;
			*(llist->tail->ptr1+length+1) = '\0';
		}
		if ((*(llist->tail->ptr1) == ' ' ||
			 *(llist->tail->ptr1+length) == 9) &&
			 *(llist->tail->ptr1+1) == '\0')
			     *(llist->tail->ptr1) = '\0';
	}
	/*  End of read file */
	/*
		Delete last empty lines
    */
	if (llist->tail==NULL) goto Close01;
	while ((llist->tail->ptr1 != 0 && strlen(llist->tail->ptr1) == 0) ||
		    llist->tail->ptr1 == 0){
        llist_remove(llist, llist->tail);
		if (llist->tail==NULL) goto Close01;
	}
	/* Delete end of file mark */
	if (llist->tail->ptr1) {
		if (strlen(llist->tail->ptr1)==1 && *llist->tail->ptr1==26)
					llist_remove(llist, llist->tail);
	}
	if (llist->tail->ptr1==0 && llist->tail->ptr2==0 &&
		llist->tail->list1==0 && llist->tail->list2==0 &&
		llist->tail->next==0) llist_remove(llist, llist->tail);
	/*
	dump = llist->head;
	while (dump) {
		fprintf (stderr, "%d %s\n", dump->id, dump->ptr1);
		dump = dump->next;
	}
	*/
Close01:
	fclose (fi);
	return llist;
}
